/*
 *  ******************************************************************************
 *  *
 *  *
 *  * This program and the accompanying materials are made available under the
 *  * terms of the Apache License, Version 2.0 which is available at
 *  * https://www.apache.org/licenses/LICENSE-2.0.
 *  *
 *  *  See the NOTICE file distributed with this work for additional
 *  *  information regarding copyright ownership.
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  * License for the specific language governing permissions and limitations
 *  * under the License.
 *  *
 *  * SPDX-License-Identifier: Apache-2.0
 *  *****************************************************************************
 */

package org.deeplearning4j.bagofwords.vectorizer;

import org.deeplearning4j.models.word2vec.InputStreamCreator;
import org.deeplearning4j.text.documentiterator.DocumentIterator;

import java.io.InputStream;

public class DefaultInputStreamCreator implements InputStreamCreator {
    private final DocumentIterator iter;

    public DefaultInputStreamCreator(DocumentIterator iter) {
        this.iter = iter;
    }

    @Override
    public InputStream create() {
        return iter.nextDocument();
    }
}
